 /*  for external eeprom AT24CP32N adress up to FF
adress select chip A0,A1,A2 to GND (pin 1,2,3 to 4)
 

#include "eee_float.h"

char tok;        // one byte variable "tok"
tok=E2P_read_char(0x00);  // read tok from eeprom on adress 0x00
E2P_write_char(0x00,tok); // write tok in eeprom on adress 0x00

unsigned int tok;        // double-byte variable "tok"
tok=E2P_read_int(0x00);  // read tok from eeprom on adress 0x00
E2P_write_int(0x00,tok); // write tok in eeprom on adress 0x00

float Fy;
E2P_write_float(0x06,Fy); // record in eeprom on adress 0x06 float Fx=3.1415926
Fy=E2P_read_float(0x06); // read from adress 006 float Fx=3.1415926

long Lx;
E2P_write_long(0x02,Lx); // record in eeprom on adress 0x02 long Lx=345867;
Lx=E2P_read_long(0x02); // read from adress 002 long Lx=345867

      
 */


void E2P_write_char(char bytes, char one2_byte){

  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA0);          // send byte via I2C  (device address + W)
  TWI_Write(0x00);          // send Hi byte (address of EEPROM location)
  TWI_Write(bytes);         // send Low byte (address of EEPROM location)
  TWI_Write(one2_byte);     // send data Low byte (data to be written)
  TWI_Stop();               // issue I2C stop signal
  Delay_ms(15);

}


char E2P_read_char(char bytes){
  char high2_byte;
  // -----------------------------------------------
  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA0);          // send byte via I2C  (device address + W)
  TWI_Write(0x00);          // send Hi byte (address of EEPROM location)
  TWI_Write(bytes);        // send Low byte (address of EEPROM location)
  TWI_Stop();               // issue I2C stop signal

  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA1);          // send byte (device address + R)
  // low2_byte = TWI_Read(1u);     // Read Lo byte the data (acknowledge)
  high2_byte = TWI_Read(0u);    // Read Hi byte the data (NO acknowledge)

  TWI_Stop();               // issue I2C stop signal
  Delay_ms(15);
  return (high2_byte);           //     
}


  unsigned char lowww (unsigned int two2_byte)  //     
  {return (two2_byte&0b0000000011111111);}

  unsigned char highww (unsigned int two2_byte) //     
  {return ((two2_byte&0b1111111100000000)>>8);}


void E2P_write_int(char bytes, unsigned int two2_byte){
    unsigned char low2_byte, high2_byte;
    low2_byte=lowww(two2_byte);
    high2_byte=highww(two2_byte);
  // -------------------------------------------------
  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA0);          // send byte via I2C  (device address + W)
  TWI_Write(0x00);          // send Hi byte (address of EEPROM location)
  TWI_Write(bytes);         // send Low byte (address of EEPROM location)
  TWI_Write(low2_byte);     // send data Low byte (data to be written)
  TWI_Write(high2_byte);    // send data Hi byte (data to be written)
  TWI_Stop();               // issue I2C stop signal
  Delay_ms(15);

}


unsigned int E2P_read_int(char bytes){
    unsigned int two2_byte;
    unsigned char low2_byte, high2_byte;
  // -----------------------------------------------
  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA0);          // send byte via I2C  (device address + W)
  TWI_Write(0x00);          // send Hi byte (address of EEPROM location)
  TWI_Write(bytes);        // send Low byte (address of EEPROM location)
  TWI_Stop();               // issue I2C stop signal

  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA1);          // send byte (device address + R)
  low2_byte = TWI_Read(1u);     // Read Lo byte the data (acknowledge)
  high2_byte = TWI_Read(0u);    // Read Hi byte the data (NO acknowledge)

  TWI_Stop();               // issue I2C stop signal

  two2_byte = high2_byte;
  two2_byte = (two2_byte << 8) + low2_byte;

  return (two2_byte);           //     
}

   void E2P_write_float(char addr, float float_var) //      addr    float
{
    unsigned short* pSell;
    short i;
    pSell=&float_var;
// ------------------------------------
  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA0);          // send byte via I2C  (device address + W)
  TWI_Write(0x00);          // send Hi byte (address of EEPROM location)
  TWI_Write(addr);         // send Low byte (address of EEPROM location)
// ------------------------------------
    for (i=0; i<4; ++i)
        // EEPROM_Write(addr+i,*(pSell+i));
        TWI_Write(*(pSell+i));     // send data byte (data to be written)
// ------------------------------------
  TWI_Stop();               // issue I2C stop signal
  Delay_ms(15);


}

float E2P_read_float(unsigned int addr)
{
      unsigned char high2_byte;
      unsigned char i;
      float result;
      float* pResult;
      unsigned char* temp;
      temp=&result;
// ---------------------------------
  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA0);          // send byte via I2C  (device address + W)
  TWI_Write(0x00);          // send Hi byte (address of EEPROM location)
  TWI_Write(addr);        // send Low byte (address of EEPROM location)
  TWI_Stop();               // issue I2C stop signal

  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA1);          // send byte (device address + R)

// ----------------------------------
      
      for(i=0; i<4; ++i)
      *(temp+i) = TWI_Read(1u);     // Read Lo byte the data (acknowledge)
      high2_byte = TWI_Read(0u);    // Read Hi byte the data (NO acknowledge)
      TWI_Stop();               // issue I2C stop signal
         
// -----------------------------------
      return result;
}

 void E2P_write_long(unsigned int addr, unsigned long four_byte) //      addr    long int
{
    unsigned char f_byte;
    unsigned char s_byte;
    unsigned char t_byte;
    unsigned char fth_byte;

    f_byte =    four_byte&0xFF;
    s_byte =   (four_byte&0xFF00)>>8;
    t_byte  =  (four_byte&0xFF0000)>>16;
    fth_byte = (four_byte&0xFF000000)>>24;
// ------------------------------------
  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA0);          // send byte via I2C  (device address + W)
  TWI_Write(0x00);          // send Hi byte (address of EEPROM location)
  TWI_Write(addr);         // send Low byte (address of EEPROM location)
// ------------------------------------

  TWI_Write(f_byte);    // send data Lo byte (data to be written)
  TWI_Write(s_byte);    // send data Hi byte (data to be written)
  TWI_Write(t_byte);    // send data Hi byte (data to be written)
  TWI_Write(fth_byte);    // send data Hi byte (data to be written)
  
// -------------------------------------
  TWI_Stop();               // issue I2C stop signal
  Delay_ms(15);
}

 unsigned long E2P_read_long(unsigned int addr)
  {
  unsigned long four_byte2;
  unsigned char f_byte;
  unsigned char s_byte;
  unsigned char t_byte;
  unsigned char fth_byte;
  // -----------------------------------------------
  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA0);          // send byte via I2C  (device address + W)
  TWI_Write(0x00);          // send Hi byte (address of EEPROM location)
  TWI_Write(addr);        // send Low byte (address of EEPROM location)
  TWI_Stop();               // issue I2C stop signal

  TWI_Start();              // issue I2C start signal
  TWI_Write(0xA1);          // send byte (device address + R)
  f_byte = TWI_Read(1u);     // Read Lo byte the data (acknowledge)
  s_byte = TWI_Read(1u);     // Read Lo1 byte the data (acknowledge)
  t_byte = TWI_Read(1u);     // Read Lo2 byte the data (acknowledge)
  fth_byte = TWI_Read(0u);    // Read Hi byte the data (NO acknowledge)

  TWI_Stop();               // issue I2C stop signal

  four_byte2 = fth_byte;
  four_byte2 = (four_byte2 << 8) + t_byte;
  four_byte2 = (four_byte2 << 8) + s_byte;
  four_byte2 = (four_byte2 << 8) + f_byte;

  return (four_byte2);           //     
  }